
ChiliProject - Bug # 1142: Darcs repository adapter doesn't work with newer versions (~2.5) of Darcs
Affected version: 3.3.0
Description: This fails e.g. on Travis: http://travis-ci.org/#!/chiliproject/chiliproject/builds/2425042

I'm pondering completely dropping Darcs support (or at least announcing only support for Darcs < 2.5). Any 
thoughts?

Associated revisions
2013-01-02 04:16 pm - Holger Just 
Install Darcs 2.3 on Travis CI #1142

Our tests break on Darcs >=2.5 as Darcs changed the repository
format and the command API.

History
2012-09-13 12:51 am - Toshi MARUYAMA
http://travis-ci.org/#!/chiliproject/chiliproject/jobs/2425043/L1696
<pre>
ERROR: repository upgrade required, try `darcs optimize --upgrade`
See http://wiki.darcs.net/OF for more details.
</pre>

http://wiki.darcs.net/OF
> There are currently three Darcs repository formats: old-fashioned (OF), hashed and darcs-2. Versions 2.5.x of Darcs are the last one that ensure full 
support of OF repositories. From version 2.8 (2012) , this support is limited and users are invited to upgrade their OF repositories to hashed.

2012-09-13 12:57 am - Toshi MARUYAMA
<pre>
$ LC_ALL=C wget http://eric.kow.free.fr/download/darcs-1.0.9-i386-linux.gz
--2012-09-13 07:54:19--  http://eric.kow.free.fr/download/darcs-1.0.9-i386-linux.gz
Resolving eric.kow.free.fr... 212.27.63.109
Connecting to eric.kow.free.fr|212.27.63.109|:80... connected.
HTTP request sent, awaiting response... 200 OK
Length: 1949659 (1.9M) [application/x-gzip]
Saving to: `darcs-1.0.9-i386-linux.gz'

100%[=================================================================>] 1,949,659   41.4K/s   in 63s     

2012-09-13 07:55:23 (30.1 KB/s) - `darcs-1.0.9-i386-linux.gz' saved [1949659/1949659]

$ md5sum darcs-1.0.9-i386-linux.gz 
496a8d1e32cc44584810c73165d139ad  darcs-1.0.9-i386-linux.gz
$ ll darcs-1.0.9-i386-linux.gz 
-rw-rw-r-- 1 xxxx xxxx 1949659 2007-08-29 03:05 darcs-1.0.9-i386-linux.gz

</pre>
2012-09-13 01:03 am - Toshi MARUYAMA
http://packages.debian.org/squeeze/darcs
> 2.4.4-3

2012-09-13 01:31 am - Toshi MARUYAMA
<pre>
$ LC_ALL=C hg pare
changeset:   10350:2dd4d398dae3
tag:         tip
parent:      10348:e308c725e138
user:        emassip
date:        Wed Sep 12 21:30:30 2012 +0000
summary:     Fixed comment.

$ darcs --version
2.8.0 (release)
</pre>

<pre>
$ ruby test/unit/lib/redmine/scm/adapters/darcs_adapter_test.rb 
Loaded suite test/unit/lib/redmine/scm/adapters/darcs_adapter_test
Started
.
darcs failed:  Unable to "darcs annotate" here.

ERROR: repository upgrade required, try `darcs optimize --upgrade`
See http://wiki.darcs.net/OF for more details.

darcs failed:  Unable to "darcs annotate" here.

ERROR: repository upgrade required, try `darcs optimize --upgrade`
See http://wiki.darcs.net/OF for more details.

darcs failed:  Unable to "darcs annotate" here.

ERROR: repository upgrade required, try `darcs optimize --upgrade`
See http://wiki.darcs.net/OF for more details.

darcs failed:  Unable to "darcs annotate" here.

ERROR: repository upgrade required, try `darcs optimize --upgrade`
See http://wiki.darcs.net/OF for more details.

darcs failed:  Unable to "darcs annotate" here.

ERROR: repository upgrade required, try `darcs optimize --upgrade`
See http://wiki.darcs.net/OF for more details.

darcs failed:  Unable to "darcs annotate" here.

ERROR: repository upgrade required, try `darcs optimize --upgrade`
See http://wiki.darcs.net/OF for more details.
F
Finished in 2.027016 seconds.

  1) Failure:
test_revisions(DarcsAdapterTest) [test/unit/lib/redmine/scm/adapters/darcs_adapter_test.rb:25]:
<"20080308225258-98289-761f654d669045eabee90b91b53a21ce5593cadf.gz"> expected but was
<"20080308225258-98289-761f654d669045eabee90b91b53a21ce5593cadf">.

2 tests, 6 assertions, 1 failures, 0 errors
</pre>

2012-09-13 08:20 am - Holger Just
Unfortunately, simply upgrading to the hashed repository format doesn't suffice. It significantly reduces the line noise (and indeed fixes a couple of 
tests) but not all of them. Even with the new format, I still have ~10 test failures in the two adapter unit tests as well as the controller test which I 
couldn't fully pindown.

2012-12-16 05:34 pm - Holger Just
- Assignee set to Holger Just

With https://github.com/chiliproject/chiliproject/pull/230 we install Darcs 2.3 on Travis CI from the Ubuntu Lucy repository.

If nobody steps up in the meantime to fix Darcs integration, we will pull it out of the ChiliProject core soon as apparently nobody actually uses it and it is 
a pain to maintain currently.

2013-01-02 10:27 pm - Holger Just
- Status changed from Open to Closed

We now use the Darcs package from Ubuntu Lucy on Travis. This fixes the tests for now.
